﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;

namespace DWBattMain
{
     partial class frm_Main 
    {

         private void InitializeSerialPort()
         {
             //String[] strAvailableSerialPorts = new string[12];
             //GetAllSerialPortNames(strAvailableSerialPorts);

             //configuring the serial port
             serialPort1.PortName = "COM1";
             serialPort1.BaudRate = 9600;
             serialPort1.DataBits = 8;
             serialPort1.Parity = Parity.None;
             serialPort1.StopBits = StopBits.One;
             serialPort1.ReadTimeout = 100;
             serialPort1.WriteBufferSize = 100;

             //opening the serial port
             serialPort1.Open();
         }

         private string strReadADLineFromSerialPort(string strOriginalCmd)
         {   // wait 200ms for A/D module response then leave
             WaitXSeconds(.1);
             string strADModuleResponse = "";
             try
             {
                 //Console.WriteLine("Reading Ser Port");
                 strADModuleResponse = serialPort1.ReadLine();  // wait for entire line but only for short time then move on
                 //Console.WriteLine("ABytes Remaining = " + serialPort1.BytesToRead);
             }
             catch (TimeoutException) { Console.WriteLine("Serial Response Error - " + strADModuleResponse); }

             // if we only got the cmd echo then try one more time
             if ((strADModuleResponse == strOriginalCmd) || (serialPort1.BytesToRead > 0))
             {
                 WaitXSeconds(.1);
                 strADModuleResponse = serialPort1.ReadExisting();  // get cmd response
                 //Console.WriteLine("Bytes Remaining = " + serialPort1.BytesToRead);
             }

             // now strip out any cr/lf and the original cmd sent
             strADModuleResponse = strCleanUpADCmdResponse(strOriginalCmd, strADModuleResponse);
             return strADModuleResponse;
         }

         public static void GetAllSerialPortNames(String[] strAllCommPorts)
         {
             SerialPort spSerialPort = new SerialPort();

             int iPortCounter = 0;

             Console.WriteLine("Available Ports:");
             foreach (string s in SerialPort.GetPortNames())
             {
                 Console.WriteLine("   {0}", s);
                 iPortCounter++;
                 strAllCommPorts[iPortCounter] = s;
             }
         }



    }
}
