﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DWBattMain
{
    public partial class frm_Main
    {

        // Return part of a string, right, mid or left

        public static string RightString(string ExistingString, string Delimeter)
        {
            string RightPartOfString = "";
            // determine where in the string is the Delimeter and get how many chars from that position
            if (ExistingString.IndexOf(Delimeter) >= 0)
            {
                int RStringLen = ExistingString.Length - ExistingString.IndexOf(Delimeter);
                // now get only that portion of the string beyond the Delimeter
                if (ExistingString.IndexOf(Delimeter) == ExistingString.Length) // if delimeter at end then ret left side
                    { RightPartOfString = LeftStringDelimited(ExistingString, Delimeter); }
                else
                    { RightPartOfString = ExistingString.Substring(ExistingString.IndexOf(Delimeter) + Delimeter.Length, RStringLen - Delimeter.Length); }
                // now return that string
                return RightPartOfString;
            }
            else
            {
                return ExistingString;
            }
        }

        private static string LeftStringDelimited(string ExistingString, string Delimeter)
        {
            if (ExistingString.IndexOf(Delimeter) >= 0)
            {
                // determine where in the string is the Delimeter, we want the chars in front of the Delimeter
                int LStringLen = ExistingString.IndexOf(Delimeter);
                // now get only that portion of the string beyond the Delimeter
                string LeftPartOfString = ExistingString.Substring(1, LStringLen-1);
                // now return that string
                return LeftPartOfString;
            }
            else
            {
                return ExistingString;
            }
        }

        private static string LeftStringPosition(string ExistingString, int NumCharsToStrip)
        {
            if (NumCharsToStrip > 0)
            {
                // now get the left part of the string
                string LeftPartOfString = ExistingString.Remove(ExistingString.Length - NumCharsToStrip, NumCharsToStrip);
                // now return that string
                return LeftPartOfString;
            }
            else
            {
                return ExistingString;
            }
        }

        private static string FormatNumberToString(Double ValueToConvert, int StringFormatType, int NumDecimalPlaces)
        {
            string ValueToString = "";
            if (StringFormatType == 1) // number to decimal, return as string
            {
                // Convert the value to a string
                ValueToString = ValueToConvert.ToString();
                // now if there is a fractional part, return only specified decimal places
                int DecimalPointPos = ValueToString.IndexOf(".")+1;
                // if no decimal point, then add and pad with 0s return value
                if (DecimalPointPos == 0)
                    { return ValueToString + ".000"; }
                else
                // return specified decimal places
                {
                    ValueToString = LeftStringPosition(ValueToString, ValueToString.Length - DecimalPointPos - NumDecimalPlaces);
                    // now return that string
                    return ValueToString;
                }
            }
            else
            {
                return ValueToString;
            }
        }


        private static string FormatValueToString(double dbValue, string Formatting)
        {
            string TempString = String.Format(Formatting, dbValue);
            return TempString;
        }
        
        private static double ExtractValueFromString(string SerCmdResponse, double DivideValue)
        {
            //'string will contain a value within ie; 9972.00 from $1RDcr*+09972.00cr*cr
            //'strip off extraneous leading chars from module cmd echo back
            string StringWithValue = RightString(SerCmdResponse, "*");
            string TempString = "0";
            double retADSerValue = 0;

            //for (int StringPosCount = 0; StringPosCount <= TempString.Length; StringPosCount++)
            //{
            //      //'check each position to see if it is a number or decimal point, if it is then use it
            foreach (char c in StringWithValue)
            {
                if ((char.IsNumber(c)) || (c == (char)46))
                {
                    TempString = TempString + c;
                }
                else if ((c == (char)10) || (c == (char)13))
                    break;

            }
            Double ADRetValue = double.Parse(TempString);

            retADSerValue = ADRetValue / DivideValue;

            Console.WriteLine(retADSerValue);
            return retADSerValue;
        }

        private static string strCleanUpADCmdResponse(string strCmd, string strSerADModResponse)
        {   // clean any cr/lf from string and also any part containing orig cmd echo'd
            string TempString = "";
            foreach (char c in strSerADModResponse)
            {
                if ((c == (char)10) || (c == (char)13))
                {
                    //ignore;
                }
                else
                {
                    TempString = TempString + c;
                }
            }
            // now see if have cmd string in string
            if (TempString.IndexOf(strCmd) > 0)
            { TempString = TempString.Replace(strCmd, ""); }
            // now extract only the a/d value from the string
            TempString = RightString(TempString, "*+");

            return TempString;
        }

        public string strADValueScale(string ADRawValue, double dScaleFactorChan1)
        {

            double ADModRetValue = dScaleFactorChan1 * ExtractValueFromString(ADRawValue, 1000);
            return FormatNumberToString(ADModRetValue, 1,  3);
        }

    }
}
